#ifndef __HASH_H__
#define __HASH_H__

#ifdef __cplusplus
#define EXTERN_CPP extern "C"
#else
#define EXTERN_CPP
#endif /* __cplusplus */

#ifdef _WIN32
typedef ULONGLONG ulong64;
typedef ULONG     dword;
typedef USHORT    word;
typedef UCHAR     byte;
#endif


typedef struct struct_hash_element {
   struct struct_hash_element *next;
   dword  data;
   byte   key[4];
} type_hash_element;


EXTERN_CPP void *open_hash(int hash_length, int hash_elements);
EXTERN_CPP int close_hash(void *handle);
EXTERN_CPP type_hash_element *addhash(void *handle, byte *key, dword data);
EXTERN_CPP type_hash_element *findhash(void *handle, byte *key);
EXTERN_CPP int delhash(void *handle, byte *key);

EXTERN_CPP void init_crc(void);
EXTERN_CPP dword crc8(dword crc, byte *data, int len);

#endif
